package ch.vorburger.jpapattern.framework;

/**
 * Marker interface for "Null Objects".
 * 
 * Not specific to JPA, no specific contract on what it's methods do is implied;
 * intended to be used for other non-JPA Entity Null Objects.
 * 
 * Classes implementing Null are Singletons.
 * Classes implementing Null must override {@link Nullable#isNull()} to return true.
 * 
 * @see http://en.wikipedia.org/wiki/Null_Object_pattern
 */
public interface Null extends Nullable {

}
