package ch.vorburger.jpapattern.sample.entities;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import ch.vorburger.jpapattern.framework.Nullable;
import ch.vorburger.jpapattern.framework.aop.NullEntityFactory;

/**
 * Sample JPA Entity, simple.
 *
 * @author Michael Vorburger
 */
@Entity
@Table(name = "test_c")
public class BEntity implements Nullable {

    @Id
    private Long id;
    
    private String name;

    @ManyToOne(cascade = CascadeType.ALL, fetch = FetchType.LAZY, optional = true)
    @JoinColumn(nullable = true, name = "d_id") // NOTE: This one CAN be NULL
    private CEntity c;

    public Long getId() {
        return id;
    }

    public String getName() {
        return name;
    }
    
    public void setName(String _name) {
        this.name = _name;
    }


	public void setC(CEntity c) {
		this.c = c;
	}

	public CEntity getC() {
		// @see AEntity#getB()
		return (c != null) ? c : NullEntityFactory.theNullObject(CEntity.class); 
	}
	
	/* (non-Javadoc)
	 * @see ch.vorburger.jpapattern.framework.Nullable#isNull()
	 */
    @Override
	public boolean isNull() {
		return false;
	}
}
