package ch.vorburger.jpapattern.sample.entities.nulls;

import ch.vorburger.jpapattern.framework.NullEntity;
import ch.vorburger.jpapattern.sample.entities.AEntity;
import ch.vorburger.jpapattern.sample.entities.BEntity;

/**
 * Null Entity of BEntity.
 *
 * @see NullEntity
 * @see AEntity#getB()
 *
 * @author Michael Vorburger
 */
public final class NullCEntity extends BEntity implements NullEntity {

    public static final NullCEntity NULL = new NullCEntity();
    private NullCEntity() {
    }

    @Override
    public Long getId() {
        return null;
    }

    @Override
    public String getName() {
        return null;
    }

    @Override
    public void setName(String name) {
        throw new UnsupportedOperationException(NullCEntity.class + UOE_MSG + "name");
    }

	/* (non-Javadoc)
	 * @see testOpenJPA.TypeEntity#isNull()
	 */
	@Override
	public boolean isNull() {
		return true;
	}
}
